/****************************************************************************
*  Copyright (C) 2008-2012 by Michael Fischer.
*  
*  All rights reserved.
*
*  Redistribution and use in source and binary forms, with or without 
*  modification, are permitted provided that the following conditions 
*  are met:
*  
*  1. Redistributions of source code must retain the above copyright 
*     notice, this list of conditions and the following disclaimer.
*  2. Redistributions in binary form must reproduce the above copyright
*     notice, this list of conditions and the following disclaimer in the 
*     documentation and/or other materials provided with the distribution.
*  3. Neither the name of the author nor the names of its contributors may 
*     be used to endorse or promote products derived from this software 
*     without specific prior written permission.
*
*  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS 
*  "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT 
*  LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS 
*  FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL 
*  THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, 
*  INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, 
*  BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS 
*  OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED 
*  AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, 
*  OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF 
*  THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF 
*  SUCH DAMAGE.
*
*****************************************************************************
*  History:
*
*  01.10.08  mifi   First Version
****************************************************************************/
#if !defined(__UART_H__)
#define __UART_H__
/************************************************** ***************************
* Public function prototypes
************************************************** **************************/
#include "system.h"
#include "altera_avalon_uart_regs.h"
#include "sys/alt_irq.h"
#include "priv/alt_legacy_irq.h"
#include <alt_types.h>

#define UART1_BASE UART_0_BASE
#define UART1_IRQ UART_0_IRQ
#define UART1_FREQ UART_0_FREQ
#define UART1_IRQ_ID UART_0_IRQ_INTERRUPT_CONTROLLER_ID


#define UART_BASE UART_0_BASE
#define UART_IRQ UART_0_IRQ
#define UART_FREQ UART_0_FREQ
#define UART_IRQ_ID UART_0_IRQ_INTERRUPT_CONTROLLER_ID

void uart_handle(void *context,alt_u32 interrupt);
void InitUart1(unsigned int BaudRate);
void InitUart(unsigned int baud_rate);
void IsrUart1(void* context, unsigned int id);


unsigned char EmptyUart1(unsigned short* head,unsigned short* tail);//
unsigned short GET_POS(void);
unsigned short CLEAR_FIFO(void);
unsigned char GetUart1(void);
unsigned char PutUart1(unsigned char in_char);
int  get_pack_data_uart(unsigned char * buffer);

unsigned char uart_write(unsigned char * pack, int len);

#define NULL ((void *)0)

#endif /* !__UART_H__ */
/*** EOF ***/
